<template>
  <div class="stopwatch-group">
    <div class="stopwatch">
      <div class="stopwatch-controls">
        <div class="stopwatch-running">⏺</div>
        <div class="timer-placeholder">{{hours}}:{{minutes}}:{{seconds}}</div>
        <button v-if="!isTimerRunning" @click="startStopSession">▶</button>
        <button v-if="isTimerRunning"  @click="startStopSession">⏸</button>
        <button @click="saveSession">⏹</button>
      </div>
      <div class="stopwatch-title">
        <span>{{ sessionName }}</span>
      </div>
      <button class="stopwatch-menu">...</button>
    </div>
    <!-- <div class="stopwatch-options"></div> -->
  </div>
</template>

<script>
export default {
  name: "Stopwatch",
  props: ['sessionName'], 
  data: function() {
    return {
      isTimerRunning: false,
      hours: "00",
      minutes: "00",
      seconds: "00", 
      calculatedTime: null
    };
  },
  mounted: function() {
    this.isTimerRunning = this.$stpw.isRunning;
    window.setInterval(() => {
      this.updateDisplay();
    }, 200);
  },
  methods: {
    startStopSession: function() {
      if (!this.$stpw.isRunning) this.$stpw.startTimer();
      else this.$stpw.pauseTimer();

      this.isTimerRunning = this.$stpw.isRunning;
    },
    resetSession: function() {
      this.$stpw.resetTimer();
      this.isTimerRunning = this.$stpw.isRunning;
    },
    saveSession: function() {
      this.$stpw.stopTimer();
      this.$emit("save-session", {
          title: this.sessionName, 
          duration: this.calculatedTime.seconds, 
          startingDate: this.$stpw.startingDate, 
          endingDate: this.$stpw.endingDate 
      });
      this.resetSession();
      this.isTimerRunning = this.$stpw.isRunning;
    },
    updateDisplay: function() {
      this.calculatedTime = this.$stpw.outputStopwatch();
      if (this.calculatedTime) {
        this.seconds =
          this.calculatedTime.seconds % 60 < 10
            ? "0" + (this.calculatedTime.seconds % 60)
            : this.calculatedTime.seconds % 60;
        this.minutes =
          this.calculatedTime.minutes % 60 < 10
            ? "0" + (this.calculatedTime.minutes % 60)
            : this.calculatedTime.minutes % 60;
      } else {
        this.hours = "00";
        this.minutes = "00";
        this.seconds = "00";
      }
    }
  }
};
</script>

<style scoped>
.stopwatch-group {
  font-size: 22px;
  border: 1px solid lightgray;
  padding: 10px;
}

.stopwatch,
.stopwatch-controls {
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
}



.stopwatch {
  border: 1px solid lightgray;
  padding: 10px;
  background-color: white;
}

.stopwatch-controls {
  font-size: 18px;
}

.timer-placeholder {
  padding-left: 10px;
  padding-right: 10px;
  font-size: 22px;
}

.stopwatch-running {
    color: red;
}

button {
  border: 0px;
  margin: 0px;
  padding: 0px;
  padding-left: 5px;
}

.stopwatch-title {
  padding-left: 20px;
  flex-grow: 1;
  text-align: left !important;
}

.stopwatch-menu {
  writing-mode: vertical-lr;
  text-orientation: mixed;
}

.stopwatch-options {
  height: 150px;
  border: 1px solid lightgray;
  padding: 10px;
  background-color: white;
}
</style>

